---
title: Xamarin.Android warning XA1029
description: XA1029 warning code
ms.date: 09/06/2022
---
# Xamarin.Android warning XA1029

## Example messages

```
warning XA1029: The 'AotAssemblies' MSBuild property is deprecated. Edit the project file in a text editor to remove this property, and use the 'RunAOTCompilation' MSBuild property instead.
```

## Solution

Instead of using:

```xml
<PropertyGroup Condition=" '$(Configuration)' == 'Release' ">
  <AotAssemblies>true</AotAssemblies>
</PropertyGroup>
```

Use instead:

```xml
<PropertyGroup Condition=" '$(Configuration)' == 'Release' ">
  <RunAOTCompilation>true</RunAOTCompilation>
</PropertyGroup>
```
