#### Application build and deployment

- [GitHub PR #5888](https://github.com/xamarin/xamarin-android/pull/5888):
  Use the aapt2 from the Android SDK Build-tools package.
  Due to issues with the `aapt2` builds from maven, we are now sourcing
  the version of `aapt2` we ship from the SDK build-tools on our build machines.

  If you are experiencing endless builds or `aapt2` crashes during a build you
  can try using the `aapt2` from maven which was used in previous releases.

  1. Download the `aapt2` package:

      * Windows users, download: https://dl.google.com/dl/android/maven2/com/android/tools/build/aapt2/4.0.0-6051327/aapt2-4.0.0-6051327-windows.jar

      * macOS users, download: https://dl.google.com/dl/android/maven2/com/android/tools/build/aapt2/4.0.0-6051327/aapt2-4.0.0-6051327-osx.jar

  2. Extract the `aapt2-*.jar` file into a "well-known" directory; this location will be used in the next step:

      * Windows:

            cd %USERPROFILE%
            mkdir xa-tools
            cd xa-tools
            jar xf %USERPROFILE%\Downloads\aapt2-4.0.0-6051327-windows.jar

      * macOS:

            cd
            mkdir xa-tools
            cd xa-tools
            jar xf ~/Downloads/aapt2-4.0.0-6051327-osx.jar

  3. In the same directory as your App's `.csproj`, add or update `Directory.Build.props` to contain:

    ```xml
    <Project>

      <PropertyGroup Condition=" '$(OS)' == 'Windows_NT' ">
        <Aapt2ToolPath>$(USERPROFILE)\xa-tools</Aapt2ToolPath>
        <Aapt2ToolExe>aapt2.exe</Aapt2ToolExe>
      </PropertyGroup>

      <PropertyGroup Condition=" '$(OS)' != 'Windows_NT' ">
        <Aapt2ToolPath>$(HOME)\xa-tools</Aapt2ToolPath>
        <Aapt2ToolExe>aapt2</Aapt2ToolExe>
      </PropertyGroup>

    </Project>
    ```
